import java.util.HashMap;

public class Fibonacci {

	private HashMap<Integer, Long> fibNums = new HashMap<Integer, Long>();
	
	public long getFibWithHash(int n)
	{
		if(fibNums.containsKey(n)) 
		{
			return fibNums.get(n);
		}
		else 
		{
			if(n == 0) return 0L;
			if(n == 1) return 1L;
			else {
				long fibNum = getFibWithHash(n - 1) + getFibWithHash(n - 2);
				fibNums.put(n, fibNum);
				return fibNum;
			}
		}
	}
	
	
	public long getFibOld(int n)
	{
		if(n == 0) return 0L;
		if(n == 1) return 1L;
		
		return getFibOld(n - 1) + getFibOld(n - 2);
	}
	
}


